//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 12-1 #2
//
// Creates nodes when the user enters a fist name of type (char name[10]). 
// Each node stores the name and a pointer to the next node, and keeps the
// names in alphabetical order.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#include <string.h>

#define UNUSED 0xFFFF
#define SIZE 10

typedef node * nodeptr;

typedef struct {
   char name[SIZE];
   nodeptr next;
} node;

node list[20];
int next_node = 0;
nodeptr first = UNUSED;

void sort_list(void);
nodeptr add_node(char * newName);
void print_list(void);

void main(void) 
{
   char input[SIZE];
   
   for(;;) {
      input[0] = '\0';
      printf("Enter Name: ");
      get_string_usb(input, SIZE);
      
      add_node(input);
      sort_list();
      print_list();
   }

   for(;;);
}

nodeptr add_node(char * newName) {
   nodeptr cur;
   
   cur = &list[next_node++];
   strncpy(cur->name, newName, SIZE);
   cur->next = first;
   first = cur;
   
   
   return cur;
}

void sort_list(void) {
   nodeptr nxt = first->next;
   nodeptr ptr = first;
   
   if (next_node < 2)
      return;
   
   while(nxt != UNUSED)
   {      
      while((nxt != ptr) && (stricmp(nxt->name, ptr->name) == - 1)) {
         char tmp[SIZE];
         strcpy(tmp, ptr->name);
         strcpy(ptr->name, nxt->name);
         strcpy(nxt->name, tmp);
         ptr = ptr->next;
      }
      ptr = nxt;
      nxt = nxt->next;
   }
}

void print_list(void) {
   nodeptr ptr = first;
   
   while(ptr != UNUSED) {
      printf("\r\n[%s]\r\n", ptr->name);
      ptr = ptr -> next;
   }
}
